/*
  Calisto - An internet Talker
  Copyright (C) 1998-2001 Peter Howkins, Matthew Howkins and Simon Howkins

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,     
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License   
  along with this program; if not, write to the Free Software
  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

  Email: calisto@calisto.cx

  $Id: inifile2.h,v 1.2 2000/12/29 20:59:26 peter Exp $

 */

#ifndef inifile2_h
#define inifile2_h
/* must be a way to stick most of this back into the .c file */
typedef struct inifile_line inifile_line;
typedef struct inifile_hdr INIFILE;
      
#define TOKEN_LEN 40
#define VAL_LEN 256
#define PATH_LEN 256    

struct inifile_line {
  char token[TOKEN_LEN];
  char val[VAL_LEN];
  inifile_line *next;
};   
    
struct inifile_hdr {
  char path[PATH_LEN];
  inifile_line *next;
};  

/* Open the .ini file specified by filename. if file not exist, create one
   Return 0 for OK, non-0 for problem */
INIFILE *inifile_open(const char *filename);


/* inifile_close mode defines */
#define INIFILE_DO_WRITE    0
#define INIFILE_DONT_WRITE 1

/* Close previously opened .ini file */
void inifile_close(INIFILE *, int mode);

/* Locate the token specified by token_name, interpret with format, 
   and return the value.
   Return 0 for OK, non-0 for problem */
int inifile_get_token(INIFILE *ini, const char *token_name,
                      const char *format, void *value,
                      const void *default_value);

/* alter or add a token */
int inifile_set_token(INIFILE *ini, const char *token_name,
                      const char *format, void *value);

void inifile_test(INIFILE *);

#endif /* inifile2_h */
