/*
  Calisto - An internet Talker
  Copyright (C) 1998-2001 Peter Howkins, Matthew Howkins and Simon Howkins

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,     
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License   
  along with this program; if not, write to the Free Software
  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

  Email: calisto@calisto.cx

  $Id: log.c,v 1.6 2000/12/29 21:01:50 peter Exp $

 */
static const char rcsid[] = "$Id: log.c,v 1.6 2000/12/29 21:01:50 peter Exp $";

#include <stdarg.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>

#include "config.h"
#include "log.h"
#include "msnprintf.h"
#include "strplus.h"

LOGF *usage, *debug, *bug, *idea, *typo;

void log(LOGF *log, const char *format, ...)
{
  va_list ptr;
  time_t now;
  struct tm now2;
  char buffer[256];
  FILE *f;

  /* Prepare formatted time string */
  time(&now);
  now2 = *localtime(&now);
  strftime(buffer, 256, log->dateformat, &now2);
  /* Open file and output log info */
  f = fopen(log->filename, "a");
  if (!f) {
    perror("Could not open logfile");
  } else {
    fprintf(f, "%s ", buffer);
    va_start(ptr, format);
    vfprintf(f, format, ptr);
    va_end(ptr);
    fprintf(f, "\n");
    fclose(f);
  }
  /* Output to stdout also */
/*  printf("%s ", buffer);
  va_start(ptr, format);
  vprintf(format, ptr);
  va_end(ptr);
  printf("\n");*/
}

LOGF *log_init(const char *filename, const char *dateformat)
{
  LOGF *log;

  log = malloc(sizeof(LOGF));
  if (log) {
    STRNCOPY(log->filename, filename, sizeof(log->filename));
    msnprintf(log->dateformat, sizeof(log->dateformat), "[%s]", dateformat);
  }
  return log;
}
