/*
  Calisto - An internet Talker
  Copyright (C) 1998-2001 Peter Howkins, Matthew Howkins and Simon Howkins

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,     
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License   
  along with this program; if not, write to the Free Software
  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

  Email: calisto@calisto.cx

  $Id: plugin2.h,v 1.9 2001/03/08 18:13:10 peter Exp $

 */

#ifndef plugin2_h
#define plugin2_h
#ifdef USE_PLUGINS

#include "commands.h"
#include "dllist.h"
#include "inifile2.h"
#include "plugin.h"
#include "structs.h"

typedef struct plugin plugin;

extern listhead AllPlugins;

void init_plugins(void);
void close_plugins(void);
void plugin_reload(character *c);


#define ON_NEW      0
#define ON_LOGIN    1
#define ON_LOGOUT   2
#define ON_SHUTDOWN 3
void plugin_on_char(unsigned type, character *c);
void plugin_on_void(unsigned type);

struct plugin {
  PLUGIN handle;

  unsigned int version;
  char name[40];
  char author[40];
  command *clist;
  size_t offset;
  void (*onfinger)(character *, character *, void *);
  void (*onnew)(character *, void *);
  void (*onsave)(INIFILE *, character *, void *);
  void (*onload)(INIFILE *, character *, void *);
  void (*onlogin)(character *, void *);
  void (*onlogout)(character *, void *);
  void (*oninit)(void);
  void (*onshutdown)(void);
  char helpfile[40];

  listnode pluginlink;
};

#endif /* USE_PLUGINS */
#endif /* plugin2_h */
