/*
  Calisto - An internet Talker
  Copyright (C) 1998-2001 Peter Howkins, Matthew Howkins and Simon Howkins

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,     
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License   
  along with this program; if not, write to the Free Software
  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

  Email: calisto@calisto.cx

  $Id: pool.h,v 1.4 2000/12/29 23:33:10 peter Exp $

 */

#ifndef pool_h
#define pool_h

#include <stddef.h>

typedef struct pool pool;

typedef struct {
  size_t block_size;
  unsigned usage;
  unsigned capacity;
} pool_stat_t;

pool *pool_create(size_t block_size);
void pool_destroy(pool *pool);

void *pool_malloc(pool *p);
void pool_free(void *block);

void pool_debug(const pool *p);

pool_stat_t pool_stat(const pool *p);

#endif /* pool_h */
