/*
  Calisto - An internet Talker
  Copyright (C) 1998-2001 Peter Howkins, Matthew Howkins and Simon Howkins

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,     
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License   
  along with this program; if not, write to the Free Software
  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

  Email: calisto@calisto.cx

  $Id: privs.h,v 1.6 2001/03/07 21:08:16 peter Exp $

 */

#ifndef privs_h
#define privs_h

#include "structs.h"

/* Preferences */
extern bool prefname_exists(const char *prefname);
extern bool haspref(const character *c, const char *prefname);
extern void setpref(character *c, const char *prefname);
extern void clearpref(character *c, const char *prefname);

/* Privilidges */
extern bool privname_exists(const char *privname);
extern bool haspriv(const character *c, const char *privname);
extern void setpriv(character *c, const char *privname);
extern void clearpriv(character *c, const char *privname);
extern const char *privcol(const char *privname);

  /* List all the privs (with colour) and display to character c */
extern void privs_list_all(character *c);
  /* List all the privs (with colour) that character target has, and display
     to character c */
extern void privs_list_player(character *c, character *target);

/* Ranks */
extern bool rankname_exists(const char *privname);
extern void setrank(character *c, const char *rankname);

#endif /* privs_h */
